# IWD Archive Lister

The [list-iwd.sh](list-iwd) script scans the `main/` and `iw4x/` folders under a specified root directory for `.iwd` files (which are ZIP archives). For each `.iwd` file found, it extracts the list of files inside the archive using `7z` and writes the output to a `.txt` file in a folder called `out/`.

Each `.iwd` file gets its own `.txt` file in the `out/` directory, with the same base name (e.g., `iw_00.iwd` -> `out/iw_00.iwd.txt`).

## Requirements

- [`7z`](https://www.7-zip.org/) command-line tool

### Install 7z on Debian/Ubuntu:

```bash
sudo apt update
sudo apt install p7zip-full
```

### Usage

```bash
./script.sh <root_directory>
```

Where `<root_directory>` is the path that contains both `main/` and `iw4x/` subfolders.

# IWD Archive Duplicate Finder

The [show-duplicates.py](show-duplicates.py) Python script scans all `.txt` files inside the `out/` directory, which were previously generated by extracting the contents of `.iwd` archives, and identifies duplicate file entries that appear in **more than one archive**.

It prints the results to the console and saves a full report to `out/duplicates/result.txt`.

## What It Does

- Reads every `.txt` file in the `out/` folder.
- Detects which filenames appear in **multiple** `.txt` files (i.e. shared between archives).
- Writes a detailed list of these duplicates to: out/duplicates/result.txt

Each duplicate line includes the filename and a list of `.txt` files (archives) it appears in.

## Requirements

- Python 3.x
